#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "fonts.c"
#include "lph.c"
#include "uart.h"
#include "uart.c"

#define LEDPIN PA0
#define UART_BAUD_RATE 9600

char sec = 0, min = 0, test = 0;

ISR(TIMER2_OVF_vect)
{
	test = 1;
//	char s[2];
/*	sec++;
	if(sec > 60)
	{
		sec = 0;
		min++;
	}
	dtostrf(min, 2, 0, s);
	lcd_text(30,20,FONT_NINE_DOT,s);
	dtostrf(sec, 2, 0, s);
	lcd_text(30,50,FONT_NINE_DOT,s);
*/
}

uint16_t ReadChannel(uint8_t mux)
{
  uint8_t i;
  uint16_t result;
 
  ADCSRA = (1<<ADEN) | (1<<ADPS1) | (1<<ADPS0);    // Frequenzvorteiler 
                               // setzen auf 8 (1) und ADC aktivieren (1)
 
  ADMUX = mux;                      // Kanal waehlen
  ADMUX |=  (1<<REFS0); // interne Referenzspannung nutzen 
 
  /* nach Aktivieren des ADC wird ein "Dummy-Readout" empfohlen, man liest
     also einen Wert und verwirft diesen, um den ADC "warmlaufen zu lassen" */
  ADCSRA |= (1<<ADSC);              // eine ADC-Wandlung 
  while ( ADCSRA & (1<<ADSC) ) {
     ;     // auf Abschluss der Konvertierung warten 
  }
  result = ADCW;  // ADCW muss einmal gelesen werden,
                  // sonst wird Ergebnis der nchsten Wandlung
                  // nicht bernommen.
 
  /* Eigentliche Messung - Mittelwert aus 4 aufeinanderfolgenden Wandlungen */
  result = 0; 
  for( i=0; i<4; i++ )
  {
    ADCSRA |= (1<<ADSC);            // eine Wandlung "single conversion"
    while ( ADCSRA & (1<<ADSC) ) {
      ;   // auf Abschluss der Konvertierung warten
    }
    result += ADCW;		    // Wandlungsergebnisse aufaddieren
  }
  ADCSRA &= ~(1<<ADEN);             // ADC deaktivieren (2)
 
  result /= 4;                     // Summe durch vier teilen = arithm. Mittelwert
 
  return result;
}

double helligkeit_messen(void)
{
	double helligkeit = 0;
	DDRA |= (1<<LEDPIN);
	PORTA |= (1<<LEDPIN);
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	DDRA &= ~(1<<LEDPIN);
	PORTA &= ~(1<<LEDPIN);
	while(PINA & (1<<LEDPIN))
	{
		helligkeit++;
	}
	return helligkeit;
}


int main(void)
{
	port_init();
	lcd_init();
	int zaehler = 0, zaehler_alt = 0;
	char s[6];
	
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) ); 


	
	
	fill_rect(0,0,175,131,0xFFFF);
	fill_rect(9,9,120,80,0xF800);
	fill_rect(12,12,117,77,0xABCD);
	fill_rect(45,32,95,110,0x0532);
	set_pixel(0,120,0xF800);
	set_pixel(10,120,0x07E0);
	set_pixel(20,120,0x001F);
	draw_line(10,10,100,89,0xFFE0);
	if(0b00000101 & 0b10000101)
	draw_circle(50,70,12,0x001F);
	set_window(0, 0, 178, 132);
	lcd_text(15,20,FONT_NINE_DOT,"Analog     Test");
	ASSR |= _BV(AS2);
	TCCR2A |= _BV(CS21) | _BV(CS22) | _BV(CS20);
	sei();
	zaehler = 0;
	DDRC = 0xFF;

	uart_puts("String stored in SRAM\r\n");

    uart_puts_P("String stored in FLASH\r\n");

	
	while(1)
	{
		zaehler = ReadChannel(0);
	
		dtostrf(zaehler, 4, 0, s);
		lcd_text(10,50,FONT_NINE_DOT,s);
		zaehler /= 7.81;
		
		if(!(zaehler_alt == zaehler))
		{
			draw_line(150,65,175,zaehler_alt,0xFFFF);
		

			zaehler_alt = zaehler;
		
			draw_line(150,65,175,zaehler,0x0000);
		}
			
/*		if(test)
		{
			test = 0;
			lcd_text(10,20,FONT_NINE_DOT,"over");
		}



		if(TCNT2 == 255)
		{
		sec++;
		if(sec > 59)
		{
			sec = 0;
			min++;
		}
	
		dtostrf(min, 2, 0, s);
		lcd_text(60,50,FONT_NINE_DOT,s);
		dtostrf(sec, 2, 0, s);
		lcd_text(100,50,FONT_NINE_DOT,s);
		}
*/
//		draw_line(150,65,175,zaehler+1,0x0000);

//		zaehler++;
		
/*		if(zaehler > 130)
		{
			zaehler = 0;
			draw_line(150,65,175,131,0xFFFF);
		}
*/		
//		dtostrf(helligkeit_messen(), 6, 0, s);
//		lcd_text(90,50,FONT_NINE_DOT,s);
	}
}
